; InGame Time Calculator v1.1
; made by alpines from autoit.de
; SRcom Profile: alpines
; Patched by Mohandar and DarkLink

#include <Array.au3>
#include <GUIListView.au3>

Global $aListViewItems[0], $aTimes[0], $aNames[0], $sTotalTimeSoFar = "00:00:00.00"

$hGUI = GUICreate("InGame Time Calculator", 442, 584, 192, 10)
$hTimes = GUICtrlCreateListView("Name|Split Time|Total Time", 8, 8, 426, 498)
GUICtrlSendMsg(-1, 4126, 0, 205)
GUICtrlSendMsg(-1, 4126, 1, 100)
GUICtrlSendMsg(-1, 4126, 2, 100)

GUICtrlCreateLabel("Split Time:", 8, 543, 53, 17)
$hHours = GUICtrlCreateInput("00", 76, 540, 24, 20, 1)
GUICtrlSetLimit($hHours, 2)
GUICtrlCreateLabel(":", 102, 542, 5, 17)
$hMinutes = GUICtrlCreateInput("00", 107, 540, 24, 20, 1)
GUICtrlSetLimit($hMinutes, 2)
GUICtrlCreateLabel(":", 133, 542, 5, 17)
$hSeconds = GUICtrlCreateInput("00", 138, 540, 24, 20, 1)
GUICtrlSetLimit($hSeconds, 2)
GUICtrlCreateLabel(".", 164, 542, 5, 17)
$hMilliseconds = GUICtrlCreateInput("00", 169, 540, 24, 20, 1)
GUICtrlSetLimit($hMilliseconds, 2)

$hAdd = GUICtrlCreateButton("Add", 200, 515, 68, 46)
$hDelete = GUICtrlCreateButton("Delete", 272, 515, 68, 46)
$hSave = GUICtrlCreateButton("Save", 344, 515, 91, 46)

GUICtrlCreateLabel("Name:", 8, 518, 35, 17)
$hName = GUICtrlCreateInput("", 48, 516, 145, 21)

GUICtrlCreateLabel("v1.1", 409, 565, 29, 17)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
GUICtrlSetColor(-1, 0x808080)

GUICtrlCreateLabel("Coding done by alpines - Patched by Mohandar and DarkLink", 8, 565, 357, 17)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
GUICtrlSetColor(-1, 0x808080)

GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case -3
			Exit

		Case $hAdd
			ReDim $aListViewItems[UBound($aListViewItems) + 1]
			ReDim $aNames[UBound($aNames) + 1]
			ReDim $aTimes[UBound($aTimes) + 1]

			$sHours = GUICtrlRead($hHours)
			$sMinutes = GUICtrlRead($hMinutes)
			$sSeconds = GUICtrlRead($hSeconds)
			$sMilliseconds = GUICtrlRead($hMilliseconds)

			If $sHours < 10 and StringLen($sHours) == 1 Then $sHours = "0" & $sHours
			If StringLen($sHours) == 0 Then $sHours = "00"
			If $sMinutes < 10 and StringLen($sMinutes) == 1 Then $sMinutes = "0" & $sMinutes
			If StringLen($sMinutes) == 0 Then $sMinutes = "00"
			If $sSeconds < 10 and StringLen($sSeconds) == 1 Then $sSeconds = "0" & $sSeconds
			If StringLen($sSeconds) == 0 Then $sSeconds = "00"
			If $sMilliseconds < 10 and StringLen($sMilliseconds) < 2 Then $sMilliseconds = $sMilliseconds & "00"
			If $sMilliseconds < 100 and StringLen($sMilliseconds) < 3 Then $sMilliseconds = $sMilliseconds & "0"

			$sTime = $sHours & ":" & $sMinutes & ":" & $sSeconds & "." & $sMilliseconds
			$aNames[UBound($aNames) - 1] = GUICtrlRead($hName)
			$aTimes[UBound($aTimes) - 1] = $sTime
			$sTotalTimeSoFar = _AddTimes($sTime, $sTotalTimeSoFar)

			$aListViewItems[UBound($aListViewItems) - 1] = GUICtrlCreateListViewItem(StringRegExpReplace(GUICtrlRead($hName), "(\||,)", "") & "|" & $sTime & "|" & $sTotalTimeSoFar, $hTimes)

		Case $hDelete
			If _GUICtrlListView_GetSelectedIndices($hTimes) <> "" Then
				$iSelectedIndex = Number(_GUICtrlListView_GetSelectedIndices($hTimes))
				_GUICtrlListView_DeleteItem($hTimes, $iSelectedIndex)
				_ArrayDelete($aListViewItems, $iSelectedIndex)
				_ArrayDelete($aNames, $iSelectedIndex)
				_ArrayDelete($aTimes, $iSelectedIndex)
				$sTotalTimeSoFar = "00:00:00.00"

				For $i = 0 To UBound($aNames) - 1
					GUICtrlSetData($aListViewItems[$i], $aNames[$i] & "|" & $aTimes[$i] & "|" & _AddTimes($aTimes[$i], $sTotalTimeSoFar))
					$sTotalTimeSoFar = _AddTimes($aTimes[$i], $sTotalTimeSoFar)
				Next
			EndIf

		Case $hSave
			If Not UBound($aListViewItems) Then
				MsgBox(48, "Saving File", "Unable to save the file since no data was entered.")
			Else
				$sGameName = InputBox("Game Name", "Enter game name and category.")


				$sData = $sGameName & @CRLF & @CRLF & "Track times:     Total Time:" & @CRLF

				For $i = 0 To UBound($aListViewItems) - 1
					$aSplit = StringSplit(GUICtrlRead($aListViewItems[$i]), "|", 3)
					$sData &= $aSplit[0] & ", " & _CutMs($aSplit[1]) & ", " & _CutMs($aSplit[2]) & @CRLF
				Next

				$sPath = FileSaveDialog("Specify the file where you want to save your splits.", @ScriptDir, "Splitterz (*.splitterz)")
				If $sPath <> "" Then
					FileDelete($sPath)
					FileWrite($sPath, $sData)
				EndIf
			EndIf
	EndSwitch
WEnd

Func _CutMs($sTime)
    Local $aTime = StringRegExp($sTime, "(\d+)", 3)
    $aTime[3] = StringTrimRight($aTime[3], 1)

	Return $aTime[0] & ":" & $aTime[1] & ":" & $aTime[2] & "." & $aTime[3]
EndFunc

Func _AddTimes($sFirstTime, $sSecondTime)
	Local $aFirstTime = StringRegExp($sFirstTime, "(\d+)", 3)
	Local $aSecondTime = StringRegExp($sSecondTime, "(\d+)", 3)
	Local $aNewTime[4]

	;Calculate ms
	$aNewTime[3] = $aFirstTime[3] + $aSecondTime[3]
	If $aNewTime[3] >= 1000 Then
		$aNewTime[2] += 1
		$aNewTime[3] -= 1000
	EndIf

	If $aNewTime[3] < 10 Then
		$aNewTime[3] = "00" & $aNewTime[3]
	ElseIf $aNewTime[3] < 100 Then
		$aNewTime[3] = "0" & $aNewTime[3]
	EndIf

	;Calculate s
	$aNewTime[2] += $aFirstTime[2] + $aSecondTime[2]
	If $aNewTime[2] >= 60 Then
		$aNewTime[1] += 1
		$aNewTime[2] -= 60
	EndIf

	If $aNewTime[2] < 10 Then $aNewTime[2] = "0" & $aNewTime[2]

	;Calculate m
	$aNewTime[1] += $aFirstTime[1] + $aSecondTime[1]
	If $aNewTime[1] >= 60 Then
		$aNewTime[0] += 1
		$aNewTime[1] -= 60
	EndIf

	If $aNewTime[1] < 10 Then $aNewTime[1] = "0" & $aNewTime[1]

	;Calculate h
	$aNewTime[0] += $aFirstTime[0] + $aSecondTime[0]

	Return $aNewTime[0] & ":" & $aNewTime[1] & ":" & $aNewTime[2] & "." & $aNewTime[3]
EndFunc